unit Reg;

interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  IniFiles,
  Dialogs;

type
  TPasswordDlg = class(TForm)
    Label1: TLabel;
    OKBtn: TButton;
    CancelBtn: TButton;
    Memo1: TMemo;
    Button1: TButton;
    procedure PasteTo(Sender: TObject);
    procedure CancelReg(Sender: TObject);
    procedure StoreKey(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  Settings: ShortString = 'nbsl.ini';
  KeyFile: ShortString = 'nbsl.key';

var
  PasswordDlg: TPasswordDlg;

implementation

{$R *.dfm}

procedure TPasswordDlg.PasteTo(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TPasswordDlg.CancelReg(Sender: TObject);
begin
  PasswordDlg.Close;
end;

function SetRegistrationKey: PChar;stdcall;
var
  Key: Pointer;
begin
  Result := '';
  if FileExists(ExtractFilePath(ParamStr(0)) + KeyFile) then
  begin
    try
      with TFileStream.Create(ExtractFilePath(ParamStr(0)) + KeyFile, fmOpenRead) do
      try
        GetMem(Key, Size+1);
        FillChar(Key^, Size+1, 0);
        Read(Key^,Size);
      finally
        Free;
      end;
      Result := Key;
    except
  end;
  end;
end;
exports SetRegistrationKey;

procedure TPasswordDlg.StoreKey(Sender: TObject);
var
  F: TextFile;
begin
  try
    AssignFile(F, ExtractFilePath(Paramstr(0)) + KeyFile);
    Rewrite(F);
    Writeln(F, PasswordDlg.Memo1.Text);
    CloseFile(F);
  except
  end;
  CancelReg(Self);
  ShowMessage('Please restart the application to activate the key.');
end;

end.

